%global libname libtidy
%global upname tidy-html5

Name:          tidy
Version:       5.6.0
Release:       5
Summary:       Utility to clean up and pretty print HTML/XHTML/XML
License:       W3C
URL:           http://www.html-tidy.org/
Source0:       https://github.com/htacg/%{upname}/archive/%{version}.tar.gz#/%{upname}-%{version}.tar.gz

Patch0001:     0002-Issue-656-protect-against-NULL-node-set-in-loop.patch
Patch0002:     fix-memleak-in-GetTokenFromStream.patch
Patch0003:     free-attributes-before-return-NULL.patch
Patch0004:     CVE-2021-33391-pre.patch
Patch0005:     CVE-2021-33391.patch

BuildRequires: gcc-c++ cmake gcc libxslt pkgconfig
Provides:      tidy-html5 = %{version}-%{release}
Requires:      %{libname}%{?_isa} = %{version}-%{release}

%description
When editing HTML it's easy to make mistakes. Wouldn't it be nice if
there was a simple way to fix these mistakes automatically and tidy up
sloppy editing into nicely laid out markup? Well now there is! Dave
Raggett's HTML TIDY is a free utility for doing just that. It also
works great on the atrociously hard to read markup generated by
specialized HTML editors and conversion tools, and can help you
identify where you need to pay further attention on making your pages
more accessible to people with disabilities.

%package -n %{libname}
Summary: Runtime library for %{name}
%description -n %{libname}
%{summary}.

%package -n %{libname}-devel
Summary: Development files for %{name}
Obsoletes: tidy-devel < 0.99.0-10
Provides: tidy-devel = %{version}-%{release}
Requires: %{libname}%{?_isa} = %{version}-%{release}
%description -n %{libname}-devel
%{summary}.

%package_help

%prep
%autosetup -n %{upname}-%{version} -p1
ln -s tidy build/cmake/tidy5

%build
pushd build/cmake
%cmake ../../ \
  -DCMAKE_BUILD_TYPE:STRING=Release
popd
%make_build -C build/cmake

%install
%make_install -C build/cmake
ln -s tidybuffio.h $RPM_BUILD_ROOT%{_includedir}/buffio.h
ln -s tidyplatform.h $RPM_BUILD_ROOT%{_includedir}/platform.h
%delete_la_and_a

%ldconfig_scriptlets -n %{libname}

%files
%defattr(-,root,root,-)
%license README/LICENSE.md
%{_bindir}/tidy

%files -n %{libname}
%defattr(-,root,root,-)
%license README/LICENSE.md
%{_libdir}/libtidy.so.5*

%files -n %{libname}-devel
%defattr(-,root,root)
%{_includedir}/*.h
%{_libdir}/libtidy.so
%{_libdir}/pkgconfig/tidy.pc

%files help
%defattr(-,root,root)
%{_mandir}/*

%changelog
* Thu Dec 28 2023 wangkai <13474090681@163.com> - 5.6.0-5
- Fix CVE-2021-33391

* Thu Nov 26 2020 yuboyun <yuboyun@huawei.com> - 5.6.0-4
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:fix memleak in tidyParseBuffer

* Fri Nov 20 2020 lunankun <lunankun@huawei.com> - 5.6.0-3
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:fix memleak

* Wed Sep 02 2020 gaihuiying <gaihuiying1@huawei.com> - 5.6.0-2
- Type:bugfix
- DESC:change Source0 to correct URL

* Wed Feb 12 2020 openEuler Buildteam <buildteam@openeuler.org> - 5.6.0-1
- Package init
